#!/bin/sh

   if [ $# -ne 5 ]; then
         echo 1>&2 Usage: $0 userDB pswDB DBName creamDBVersion creationDBScript
         exit -1
    fi

dbVersionMustBe="$4"
#echo dbVersionMustBe=$dbVersionMustBe
echo  The database version requested by cream service is $dbVersionMustBe
creationDBScript="$5"

# Check if database db_name exist
mysqlshow --password="$2" | grep -w "$3" >/dev/null 2>&1

exitCode=$?
#echo The exit status of the last command $exitCode 

# if database doesn't exist then create and populate it
if [ "$exitCode" -ne 0 ]
then 
  echo Database $3 does not exist. Now it will be created and populated.
  mysql --password="$2" < "$creationDBScript" 2>&1
  exitCode=$?
 #echo The exit status of the last command $exitCode

  if [  "$exitCode" -ne 0 ]
  then 
    echo An error is occurred on the creation of the  database
    exit -1
  fi
fi

dbVersionFromDb=`mysql -e "select version as dbversion from db_info;" --password="$2" -D "$3" 2>&1 | tr -d "\n" | sed "s/dbversion//g"`
exitCode=$?
#echo The exit status of the last command $exitCode

if [ "`echo  $dbVersionFromDb | grep -o ERROR`" == "ERROR" ]
  then echo "Impossible to retrieve the database version from the database. The database version is set to zero."
       dbVersionFromDb=0
fi

echo The database version retrieved from the database is $dbVersionFromDb


if [ "$exitCode" -ne 0 -o X"$dbVersionMustBe" != X"$dbVersionFromDb" ]
  then
     echo "The $3 database version (db version = $dbVersionFromDb) is not compliant with the one requested by cream service (db version = $dbVersionMustBe)"

     echo Now, the updated database will be created and populated.  
     mysql --password="$2" < "$creationDBScript" 2>&1
     exitCode=$?
 #   echo The exit status of the last command $exitCode
     if [  "$exitCode" -ne 0 ]
     then
       echo 1>&2 An error is occurred on the creation of the database
       exit -1
     fi
  else
     echo "The $3 database is synchronized with the one requested by cream service"     
fi


